    001/* ========================================================================
    002 * JCommon : a free general purpose class library for the Java(tm) platform
    003 * ========================================================================
    004 *
    005 * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jcommon/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025 * in the United States and other countries.]
    026 *
    027 * ---------------------
    028 * FontWriteHandler.java
    029 * ---------------------
    030 * (C) Copyright 2003-2005, by Thomas Morgner and Contributors.
    031 *
    032 * Original Author:  Thomas Morgner;
    033 * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034 *
    035 * $Id: FontWriteHandler.java,v 1.3 2005/10/18 13:35:21 mungady Exp $
    036 *
    037 * Changes (from 25-Nov-2003)
    038 * --------------------------
    039 * 25-Nov-2003 : Added standard header (DG);
    040 *
    041 */
    042
    043package org.jfree.xml.writer.coretypes;
    044
    045import java.awt.Font;
    046import java.io.IOException;
    047
    048import org.jfree.xml.writer.AbstractXmlWriteHandler;
    049import org.jfree.xml.writer.AttributeList;
    050import org.jfree.xml.writer.XMLWriter;
    051import org.jfree.xml.writer.XMLWriterException;
    052
    053/**
    054 * A handler for writing {@link Font} objects.
    055 */
    056public class FontWriteHandler extends AbstractXmlWriteHandler  {
    057
    058    /**
    059     * Default constructor.
    060     */
    061    public FontWriteHandler() {
    062        super();
    063    }
    064
    065    /**
    066     * Performs the writing of a {@link Font} object.
    067     *
    068     * @param tagName  the tag name.
    069     * @param object  the {@link Font} object.
    070     * @param writer  the writer.
    071     * @param mPlexAttribute  ??.
    072     * @param mPlexValue  ??.
    073     *
    074     * @throws IOException if there is an I/O error.
    075     * @throws XMLWriterException if there is a writer error.
    076     */
    077    public void write(final String tagName, final Object object, final XMLWriter writer,
    078                      final String mPlexAttribute, final String mPlexValue)
    079        throws IOException, XMLWriterException {
    080        final Font font = (Font) object;
    081        final AttributeList attribs = new AttributeList();
    082        if (mPlexAttribute != null) {
    083            attribs.setAttribute(mPlexAttribute, mPlexValue);
    084        }
    085        attribs.setAttribute("family", font.getFamily());
    086        attribs.setAttribute("size", String.valueOf(font.getSize()));
    087        attribs.setAttribute("style", String.valueOf(getFontStyle(font)));
    088        writer.writeTag(tagName, attribs, true);
    089    }
    090
    091    private String getFontStyle(final Font font) {
    092        if (font.isBold() && font.isItalic()) {
    093            return "bold-italic";
    094        }
    095        if (font.isBold()) {
    096            return "bold";
    097        }
    098        if (font.isItalic()) {
    099            return "italic";
    100        }
    101        return "plain";
    102    }
    103
    104}